unit Main;{18}{program neni dodelan je potreba stisknout tlacitko Krok k aktivovani pohybu auta => informace se objevi v okne a nakonci se vse zapise do souboru vystup.txt}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Spin;

type
  TForm1 = class(TForm)
    SGMapa: TStringGrid;
    OpenDialog1: TOpenDialog;
    EdtMapa: TEdit;
    BtnProch: TButton;
    Label1: TLabel;
    BtnNacist: TButton;
    MemoLegenda: TMemo;
    MemoMapa: TMemo;
    BtnNajitTrasu: TButton;
    SERozmer: TSpinEdit;
    Label2: TLabel;
    BtnZmenit: TButton;
    MemoVystup: TMemo;
    LblX: TLabel;
    LblY: TLabel;
    Label3: TLabel;
    BtnKrok: TButton;
    LblCil: TLabel;
    procedure EdtMapaChange(Sender: TObject);
    procedure BtnProchClick(Sender: TObject);
    procedure BtnNacistClick(Sender: TObject);
    procedure BtnZmenitClick(Sender: TObject);
    procedure BtnNajitTrasuClick(Sender: TObject);
    procedure BtnKrokClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  X,Y,rychlostX,rychlostY,zmenaX,zmenaY:integer;

implementation

{$R *.dfm}

procedure TForm1.EdtMapaChange(Sender: TObject);
begin
  if EdtMapa.Text<>'' then
    BtnNacist.Enabled:=true
  else
    BtnNacist.Enabled:=False;
end;

procedure TForm1.BtnProchClick(Sender: TObject);
begin
  OpenDialog1.Execute;
  EdtMapa.Text:= OpenDialog1.FileName;
end;

procedure TForm1.BtnNacistClick(Sender: TObject);
var
  Splnuje_Kriteria:Boolean;
  pocet_sloupcu,i,radek,sloupec:Integer;

begin
  BtnNajitTrasu.Enabled:=false;
  MemoMapa.Lines.LoadFromFile(EdtMapa.Text);
  Splnuje_Kriteria:=True;
  if MemoMapa.Lines.Count>255 then Splnuje_Kriteria:=false;
  pocet_sloupcu:=length(MemoMapa.Lines[0]);
  for i:=1 to MemoMapa.Lines.Count-1 do
    if Length(MemoMapa.Lines[i])<>pocet_sloupcu then
      Splnuje_Kriteria:=false;
  if Splnuje_Kriteria then begin
    SGMapa.RowCount:=MemoMapa.Lines.Count;
    SGMapa.ColCount:= pocet_sloupcu;
    for radek:=0 to MemoMapa.Lines.Count-1 do begin
      for sloupec:=0 to pocet_sloupcu-1 do begin
        SGMapa.Cells[sloupec,radek]:=MemoMapa.Lines[radek][sloupec+1]
      end;
    end;
    BtnNajitTrasu.Enabled:=true;
  end;
end;

procedure TForm1.BtnZmenitClick(Sender: TObject);
begin
  if SERozmer.Value>0 then begin
    SGMapa.DefaultColWidth:=SERozmer.Value;
    SGMapa.DefaultRowHeight:=SERozmer.Value;
  end;
end;

procedure TForm1.BtnNajitTrasuClick(Sender: TObject);
var
  i,j:integer;
begin
  rychlostX:=0;
  rychlostY:=0;
  zmenaX:=0;
  zmenaY:=0;
  for i:=0 to SGMapa.ColCount-1 do begin
    for j:=0 to SGMapa.RowCount-1 do begin
      if SGMapa.Cells[i,j]='S' then begin
        X:=i+1;
        Y:=SGMapa.RowCount-j;
        LblX.Caption:=inttostr(X);
        LblY.Caption:=IntToStr(Y);
      end;
    end;
  end;
end;

procedure TForm1.BtnKrokClick(Sender: TObject);
var moznosti:array [1..3,1..3] of char;
    i,j:integer;
    nutnezastaveni:boolean;
begin
  {Vysledny bod pri zvyseni rychlosti X,zvyseni rychlosti Y}
  if rychlostX>-1 then begin
    zmenaX:=1;
    if rychlostY>-1 then
      zmenaY:=+1
    else zmenaY:=-1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=-1;
    if rychlostY>-1 then
      zmenaY:=+1
    else zmenaY:=-1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {pri zvyseni,0}
  if rychlostX>-1 then begin
    zmenaX:=1;
    zmenaY:=0;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][2]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=-1;
    zmenaY:=0;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][2]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {pri zvyseni,snizeni}
  if rychlostX>-1 then begin
    zmenaX:=1;
    if rychlostY>-1 then
      zmenaY:=-1
    else zmenaY:=+1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][3]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=-1;
    if rychlostY>-1 then
      zmenaY:=-1
    else zmenaY:=+1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][3]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;


  {pri 0,zvyseni}
  if rychlostY>-1 then begin
    zmenaY:=1;
    zmenaX:=0;
    rychlostY:=rychlostY+zmenaY;
    rychlostX:=rychlostX;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[2][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaY:=-1;
    zmenaX:=0;
    rychlostY:=rychlostY+zmenaY;
    rychlostX:=rychlostX;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[2][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {pri 0,0}
  zmenaY:=0;
  zmenaX:=0;
  rychlostY:=rychlostY;
  rychlostX:=rychlostX;
  if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
    moznosti[2][2]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  {pri 0,snizeni}
  if rychlostY>-1 then begin
    zmenaY:=-1;
    zmenaX:=0;
    rychlostY:=rychlostY+zmenaY;
    rychlostX:=rychlostX;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[2][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaY:=1;
    zmenaX:=0;
    rychlostY:=rychlostY+zmenaY;
    rychlostX:=rychlostX;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[2][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {snizeni,zvyseni}
  if rychlostX>-1 then begin
    zmenaX:=-1;
    if rychlostY>-1 then
      zmenaY:=+1
    else zmenaY:=-1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[3][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=+1;
    if rychlostY>-1 then
      zmenaY:=+1
    else zmenaY:=-1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[3][1]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {pri snizeni,0}
  if rychlostX>-1 then begin
    zmenaX:=-1;
    zmenaY:=0;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][2]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=+1;
    zmenaY:=0;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][2]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  {pri snizeni,snizeni}
  if rychlostX>-1 then begin
    zmenaX:=-1;
    if rychlostY>-1 then
      zmenaY:=-1
    else zmenaY:=+1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][3]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end else begin
    zmenaX:=+1;
    if rychlostY>-1 then
      zmenaY:=-1
    else zmenaY:=+1;
    rychlostX:=rychlostX+zmenaX;
    rychlostY:=rychlostY+zmenaY;
    if (X+rychlostX>0) and (X+rychlostX<SGMapa.ColCount+2) and (Y+rychlostY>0) and (Y+rychlostY<SGMapa.RowCount+2) then
      moznosti[1][3]:=SGMapa.cells[X+rychlostX-1,SGMapa.RowCount-1-Y+rychlostY][1] else moznosti[1][1]:='X';
  end;
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      if moznosti[i][j]='C' then begin
        zmenaX:=-i+2;
        zmenaY:=-j+2;
        rychlostX:=rychlostX+zmenaX;
        rychlostY:=rychlostY+zmenaY;
        X:=X+rychlostX;
        Y:=Y+rychlostY;
        MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
        LblCil.Caption:='Auto-automobil je v cli!';
        MemoVystup.Lines.SaveToFile('vystup.txt');
      end;
    end;
  end;
  nutnezastaveni:=true;
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      if (moznosti[i][j]<>'X') and (moznosti[i][j]<>'S') and (moznosti[i][j]<>'A') then begin
        nutnezastaveni:=false;
      end;
    end;
  end;
  if nutnezastaveni=true then begin
    zmenaX:=0;
    zmenaY:=0;
    rychlostX:=0;
    rychlostY:=0;
    MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
    LblCil.Caption:='Srkopedpoklda zastavil auto-automobil.';
  end else begin
    if (moznosti[1][1]='.') or (moznosti[1][1]=':') then begin
        zmenaX:=+1;
        zmenaY:=+1;
        rychlostX:=rychlostX+zmenaX;
        rychlostY:=rychlostY+zmenaY;
        X:=X+rychlostX;
        Y:=Y+rychlostY;
        SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
        MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
        LblCil.Caption:='Auto-automobil je na trase.';
    end else begin
      if (moznosti[1][2]='.') or (moznosti[1][2]=':') then begin
          zmenaX:=+1;
          zmenaY:=0;
          rychlostX:=rychlostX+zmenaX;
          rychlostY:=rychlostY+zmenaY;
          X:=X+rychlostX;
          Y:=Y+rychlostY;
          SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
          MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
          LblCil.Caption:='Auto-automobil je na trase.';
      end else begin
        if (moznosti[1][3]='.') or (moznosti[1][3]=':') then begin
            zmenaX:=+1;
            zmenaY:=-1;
            rychlostX:=rychlostX+zmenaX;
            rychlostY:=rychlostY+zmenaY;
            X:=X+rychlostX;
            Y:=Y+rychlostY;
            SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
            MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
            LblCil.Caption:='Auto-automobil je na trase.';
        end else begin
          if (moznosti[2][1]='.') or (moznosti[2][1]=':') then begin
            zmenaX:=0;
            zmenaY:=+1;
            rychlostX:=rychlostX+zmenaX;
            rychlostY:=rychlostY+zmenaY;
            X:=X+rychlostX;
            Y:=Y+rychlostY;
            SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
            MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
            LblCil.Caption:='Auto-automobil je na trase.';
          end else begin
            if (moznosti[2][2]='.') or (moznosti[2][2]=':') then begin
              zmenaX:=0;
              zmenaY:=0;
              rychlostX:=rychlostX+zmenaX;
              rychlostY:=rychlostY+zmenaY;
              X:=X+rychlostX;
              Y:=Y+rychlostY;
              SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
              MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
              LblCil.Caption:='Auto-automobil je na trase.';
            end else begin
              if (moznosti[2][3]='.') or (moznosti[2][3]=':') then begin
                zmenaX:=0;
                zmenaY:=-1;
                rychlostX:=rychlostX+zmenaX;
                rychlostY:=rychlostY+zmenaY;
                X:=X+rychlostX;
                Y:=Y+rychlostY;
                SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
                MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
                LblCil.Caption:='Auto-automobil je na trase.';
              end else begin
                if (moznosti[3][1]='.') or (moznosti[3][1]=':') then begin
                  zmenaX:=-1;
                  zmenaY:=+1;
                  rychlostX:=rychlostX+zmenaX;
                  rychlostY:=rychlostY+zmenaY;
                  X:=X+rychlostX;
                  Y:=Y+rychlostY;
                  SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
                  MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
                  LblCil.Caption:='Auto-automobil je na trase.';
                end else begin
                  if (moznosti[3][2]='.') or (moznosti[3][2]=':') then begin
                    zmenaX:=-1;
                    zmenaY:=0;
                    rychlostX:=rychlostX+zmenaX;
                    rychlostY:=rychlostY+zmenaY;
                    X:=X+rychlostX;
                    Y:=Y+rychlostY;
                    SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
                    MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
                    LblCil.Caption:='Auto-automobil je na trase.';
                  end else begin
                    if (moznosti[3][3]='.') or (moznosti[3][3]=':') then begin
                      zmenaX:=-1;
                      zmenaY:=-1;
                      rychlostX:=rychlostX+zmenaX;
                      rychlostY:=rychlostY+zmenaY;
                      X:=X+rychlostX;
                      Y:=Y+rychlostY;
                      SGMapa.Cells[X,SGMapa.RowCount-Y]:='A';
                      MemoVystup.Lines.Add(IntToStr(zmenaX)+','+IntToStr(zmenaY));
                      LblCil.Caption:='Auto-automobil je na trase.';
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

end.
